<template>
  <div class="menu q-px-md q-py-md row items-center justify-between">
    <div class="col-4">
      <q-btn-dropdown auto-close flat dense text-color="primary" label="Menu">
        <div class="column items-center">
          <q-avatar @click="openHome" class="cursor-pointer" size="72px">
            <img src="../assets/logo_shopping_cart.svg" />
          </q-avatar>
        </div>
        <q-separator color="primary" />

        <q-list style="width: 350px;">
          <q-item
            @click="openCategory(category.name)"
            v-for="category in categories"
            :key="category.id"
            clickable
            v-ripple
            class="text-center vertical-middle"
          >
            <p class="text-weight-medium">{{category.name}}</p>
          </q-item>
          <q-separator />
          <q-item
            class="bg-grey-2"
            v-if="isLoggedIn"
            dense
            clickable
            v-ripple
            @click="logout"
          >Logout</q-item>
          <q-item class="bg-grey-2" v-else dense clickable v-ripple @click="login">Login</q-item>
          <q-item class="bg-grey-2" dense v-if="isAdmin" clickable v-ripple @click="goAdmin">Admin</q-item>
        </q-list>
      </q-btn-dropdown>
      <q-btn @click="openUserProfile()" flat dense color="primary" icon="person_outline" />
    </div>
    <div class="col-4">
      <p
        @click="openHome"
        clickable
        class="text-weight-bold text-h5"
        style="text-align: center;"
      >{{ brandName }}</p>
    </div>

    <div class="col-4" v-if="isLoggedIn">
      <q-btn
        @click="openCart"
        flat
        dense
        color="primary"
        icon="shopping_cart"
        class="float-right cart-animation"
      >
        <q-badge v-if="shoppingCartSize > 0" color="secondary" floating>{{shoppingCartSize}}</q-badge>
      </q-btn>
    </div>
  </div>
</template>

<script>
import EssentialLink from "./EssentialLink.vue";
import { LocalStorage } from "quasar";

export default {
  name: "menu-page",

  data() {
    return {};
  },
  beforeMount() {
    this.$store.dispatch("adminData/loadCategories");
  },

  computed: {
    categories() {
      return this.$store.getters["adminData/getCategories"];
    },
    isAdmin() {
      const user = LocalStorage.getItem("user");
      if (this.isLoggedIn && user) return user.isAdmin;
      else return false;
    },
    isLoggedIn() {
      return LocalStorage.getItem("loggedIn");
    },
    shoppingCartSize() {
      return this.$store.getters["adminData/getShoppingCart"].reduce(
        (accumulator, item) => accumulator + item.quantity,
        0
      );
    },
    adminPreferences() {
      return this.$store.getters["adminData/getAdminPreferences"];
    },
    brandName() {
      const x = this.adminPreferences.find(
        (preference) => preference.name === "brandName"
      );
      if (x) return x.value;
      else return null;
    },
  },
  methods: {
    goAdmin() {
      this.$router.push({ name: "dashboard" });
    },
    openCart() {
      this.$router.push({ name: "cart" });
    },
    logout() {
      this.$axios
        .get("/api/auth/logout")
        .then((response) => {
          this.$q.notify({
            message: response.data.message,
            color: "positive",
          });
          LocalStorage.set("loggedIn", false);

          this.$router.push({ name: "auth" });
        })
        .catch(() => {
          this.$q.notify({
            color: "negative",
            message: "Problem",
            icon: "report_problem",
          });
        });
    },

    login() {
      this.$router.push({ name: "auth" });
    },
    openHome() {
      this.$router.push({ name: "home" });
    },
    openCategory(category) {
      this.$router.push({ name: "categoryPage", params: { category } });
    },
    openUserProfile() {
      this.$router.push({ name: "profile" });
    },
  },
};
</script>

<style lang="scss" scoped>
.menu {
  p {
    margin: 0;
    font-size: 25px;
  }
}
.cart-animation {
  animation-name: addCart;
  animation-duration: 3s ease;
}
@keyframes addCart {
  0% {
  }
  50% {
    box-shadow: 0px 0px 25px 1px rgba(146, 120, 222, 1);
    transform: scale(1.5);
  }
  100% {
  }
}
</style>
